//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3AA398BF02CE.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3AA398BF02CE.cm

//## begin module%3AA398BF02CE.cp preserve=no
//## end module%3AA398BF02CE.cp

//## Module: SPI_Data%3AA398BF02CE; Package specification
//## Subsystem: Integral%3A9FF698031B
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/Integral/SPI_Data.h

#ifndef SPI_DATA_H
#define SPI_DATA_H 1

//## begin module%3AA398BF02CE.additionalIncludes preserve=no
//## end module%3AA398BF02CE.additionalIncludes

//## begin module%3AA398BF02CE.includes preserve=yes
//## end module%3AA398BF02CE.includes

// xsTypes
#include <main/xsTypes.h>
// string
#include <string>
// OGIP-92aData
#include <XSModel/Data/OGIP-92aData.h>
//## begin module%3AA398BF02CE.declarations preserve=no
//## end module%3AA398BF02CE.declarations

//## begin module%3AA398BF02CE.additionalDeclarations preserve=yes
//## end module%3AA398BF02CE.additionalDeclarations


//## begin SPI_Data%3AA3A1A30131.preface preserve=yes
//## end SPI_Data%3AA3A1A30131.preface

//## Class: SPI_Data%3AA3A1A30131
//## Category: Integral%3A9FFB9C0025
//## Subsystem: Integral%3A9FF698031B
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class SPI_Data : public OGIP_92aData  //## Inherits: <unnamed>%3AA67FD10216
{
  //## begin SPI_Data%3AA3A1A30131.initialDeclarations preserve=yes
  //## end SPI_Data%3AA3A1A30131.initialDeclarations

  public:
    //## Constructors (generated)
      SPI_Data();

      SPI_Data(const SPI_Data &right);

    //## Destructor (generated)
      virtual ~SPI_Data();


    //## Other Operations (specified)
      //## Operation: clone%3AA682EA03A6
      virtual SPI_Data* clone () const;

      //## Operation: fileFormat%3AA6833E028C
      virtual bool fileFormat (const string& fileName, XspecDataIO::DataType type = XspecDataIO::SpectrumType);

      //## Operation: closeSourceFiles%3AC1F3FF02D9
      void closeSourceFiles ();

      //## Operation: setResponse%3AA6836B01D0
      //	setData processes the input file for a single source
      //	spectrum into a data object (e.g. SpectrumData,
      //	ResponseData). For files with multiple sources,
      //	e.g. OGIP type II files, setData will be called once for
      //	each data row to be read.
      virtual void setResponse (size_t spectrumNumber, size_t row = 0);

      //## Operation: read%3AA6849E038A
      virtual size_t read (const string& fileName, bool readFlag);

      //## Operation: reportResponse%3C03FFEE03AF
      virtual void reportResponse (size_t row) const;

      //## Operation: setResponse%3D0E05350352
      virtual bool setResponse (SpectralData* sourceSpectrum, size_t spectrumNumber, size_t specNum, const string& responseName, const string& arfName);

      //## Operation: initialize%3E8DBB0B0073
      virtual void initialize (DataPrototype* proto, DataInputRecord& record);

      //## Operation: reportAll%3E8DBECE0204
      virtual void reportAll ();

      //## Operation: report%3E91AAAB038E
      virtual void report (size_t row) const;

      //## Operation: initializeFake%3E95CFE2023C
      virtual void initializeFake (DataPrototype* proto, FakeDataInputRecord& record);

      //## Operation: getAncillaryLocation%3EB96993007C
      virtual FakeDataInputRecord::Arfs getAncillaryLocation (size_t rowNum, const FakeDataInputRecord::Detectors& respInfo) const;

      //## Operation: getBackCorrLocation%3EB9699D029C
      virtual std::pair<string,size_t>  getBackCorrLocation (size_t rowNum, bool isCorr = false) const;

      //## Operation: isMultiple%3EC158300088
      virtual bool isMultiple () const;

      //## Operation: outputData%3EE8E979009B
      virtual void outputData ();

      //## Operation: isModular%3F43DC220011
      virtual bool isModular () const;

      //## Operation: getResponseName%41F913290082
      virtual FakeDataInputRecord::Detectors getResponseName (size_t rowNum) const;

    //## Get and Set Operations for Associations (generated)

      //## Association: Integral::<unnamed>%3E8DBBF00101
      //## Role: SPI_Data::rmfNames%3E8DBBF2002F
      const StringArray& rmfNames () const;
      void rmfNames (const StringArray& value);

      //## Association: Integral::<unnamed>%3E8DBC21010D
      //## Role: SPI_Data::arfNames%3E8DBC22022B
      const StringArray& arfNames () const;
      void arfNames (const StringArray& value);

    // Additional Public Declarations
      //## begin SPI_Data%3AA3A1A30131.public preserve=yes
      //## end SPI_Data%3AA3A1A30131.public

  protected:

    //## Other Operations (specified)
      //## Operation: copy%3AA68382023A;  C++
      virtual void copy (const DataSet& right);

      //## Operation: Swap%3AA683AB0387
      virtual void Swap (DataSet& right);

      //## Operation: getRespdbInfo%3EE76DDE0165
      int getRespdbInfo (CCfits::FITS* openFile);

      //## Operation: getRespdbInfo%3EE76EF501AD
      int getRespdbInfo (const string& fileName);

      //## Operation: getNChansForFake%3EE8ABE60151
      virtual void getNChansForFake (FakeDataInputRecord& record, const size_t index, SpectralData::ChannelInfo& chanInfo);

      //## Operation: writeCommonKeys%3EE9E3F3007F
      virtual void writeCommonKeys (CCfits::Table* tbl);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: RESPONSEDB%3AA6801D013C
      static const string& RESPONSEDB ();

      //## Attribute: NRMF%3AA6801F021A
      static const string& NRMF ();

      //## Attribute: ISDCTYPE%3AA6804803C3
      static const string& ISDCTYPE ();

      //## Attribute: RESPFILEDB%3BE15B1C0180
      static const string& RESPFILEDB ();

    //## Get and Set Operations for Associations (generated)

      //## Association: Integral::<unnamed>%3AA680BF033E
      //## Role: SPI_Data::SPIspectrumKeys%3AA680C10181
      static std::vector<std::string> SPIspectrumKeys ();

    // Additional Protected Declarations
      //## begin SPI_Data%3AA3A1A30131.protected preserve=yes
      //## end SPI_Data%3AA3A1A30131.protected

  private:

    //## Other Operations (specified)
      //## Operation: makeSpectraTable%3EE9E43B0163
      CCfits::Table* makeSpectraTable (string& hduName, size_t nChans, const BoolArray& optCols);

      //## Operation: makeRespdbTable%3EE9E49903CA
      CCfits::Table* makeRespdbTable (string& hduName);

    // Additional Private Declarations
      //## begin SPI_Data%3AA3A1A30131.private preserve=yes
      //## end SPI_Data%3AA3A1A30131.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin SPI_Data::RESPONSEDB%3AA6801D013C.attr preserve=no  protected: static string {UC} "RESPONSE_DB"
      static const string s_RESPONSEDB;
      //## end SPI_Data::RESPONSEDB%3AA6801D013C.attr

      //## begin SPI_Data::NRMF%3AA6801F021A.attr preserve=no  protected: static string {UC} "NRMF"
      static const string s_NRMF;
      //## end SPI_Data::NRMF%3AA6801F021A.attr

      //## begin SPI_Data::ISDCTYPE%3AA6804803C3.attr preserve=no  protected: static string {UC} "ISDC/OGIP"
      static const string s_ISDCTYPE;
      //## end SPI_Data::ISDCTYPE%3AA6804803C3.attr

      //## begin SPI_Data::RESPFILEDB%3BE15B1C0180.attr preserve=no  protected: static string {UC} "RESPFILE_DB"
      static const string s_RESPFILEDB;
      //## end SPI_Data::RESPFILEDB%3BE15B1C0180.attr

      //## Attribute: isFirstSpectrum%3E8DF84C0284
      //## begin SPI_Data::isFirstSpectrum%3E8DF84C0284.attr preserve=no  private: bool {U} 
      bool m_isFirstSpectrum;
      //## end SPI_Data::isFirstSpectrum%3E8DF84C0284.attr

    // Data Members for Associations

      //## Association: Integral::<unnamed>%3AA680BF033E
      //## begin SPI_Data::SPIspectrumKeys%3AA680C10181.role preserve=no  protected: static std::string { -> 1..nVHgN}
      static std::vector<std::string> s_SPIspectrumKeys;
      //## end SPI_Data::SPIspectrumKeys%3AA680C10181.role

      //## Association: Integral::<unnamed>%3E8DBBF00101
      //## begin SPI_Data::rmfNames%3E8DBBF2002F.role preserve=no  public: StringArray {1 -> 1VHgN}
      StringArray m_rmfNames;
      //## end SPI_Data::rmfNames%3E8DBBF2002F.role

      //## Association: Integral::<unnamed>%3E8DBC21010D
      //## begin SPI_Data::arfNames%3E8DBC22022B.role preserve=no  public: StringArray {1 -> 1VHgN}
      StringArray m_arfNames;
      //## end SPI_Data::arfNames%3E8DBC22022B.role

    // Additional Implementation Declarations
      //## begin SPI_Data%3AA3A1A30131.implementation preserve=yes
      //## end SPI_Data%3AA3A1A30131.implementation

};

//## begin SPI_Data%3AA3A1A30131.postscript preserve=yes
//## end SPI_Data%3AA3A1A30131.postscript

// Class SPI_Data 


//## Other Operations (inline)
inline bool SPI_Data::isMultiple () const
{
  //## begin SPI_Data::isMultiple%3EC158300088.body preserve=yes
  return true;
  //## end SPI_Data::isMultiple%3EC158300088.body
}

inline bool SPI_Data::isModular () const
{
  //## begin SPI_Data::isModular%3F43DC220011.body preserve=yes
  return true;
  //## end SPI_Data::isModular%3F43DC220011.body
}

//## Get and Set Operations for Class Attributes (inline)

inline const string& SPI_Data::RESPONSEDB ()
{
  //## begin SPI_Data::RESPONSEDB%3AA6801D013C.get preserve=no
  return s_RESPONSEDB;
  //## end SPI_Data::RESPONSEDB%3AA6801D013C.get
}

inline const string& SPI_Data::NRMF ()
{
  //## begin SPI_Data::NRMF%3AA6801F021A.get preserve=no
  return s_NRMF;
  //## end SPI_Data::NRMF%3AA6801F021A.get
}

inline const string& SPI_Data::ISDCTYPE ()
{
  //## begin SPI_Data::ISDCTYPE%3AA6804803C3.get preserve=no
  return s_ISDCTYPE;
  //## end SPI_Data::ISDCTYPE%3AA6804803C3.get
}

inline const string& SPI_Data::RESPFILEDB ()
{
  //## begin SPI_Data::RESPFILEDB%3BE15B1C0180.get preserve=no
  return s_RESPFILEDB;
  //## end SPI_Data::RESPFILEDB%3BE15B1C0180.get
}

//## Get and Set Operations for Associations (inline)

inline std::vector<std::string> SPI_Data::SPIspectrumKeys ()
{
  //## begin SPI_Data::SPIspectrumKeys%3AA680C10181.get preserve=no
  return s_SPIspectrumKeys;
  //## end SPI_Data::SPIspectrumKeys%3AA680C10181.get
}

inline const StringArray& SPI_Data::rmfNames () const
{
  //## begin SPI_Data::rmfNames%3E8DBBF2002F.get preserve=no
  return m_rmfNames;
  //## end SPI_Data::rmfNames%3E8DBBF2002F.get
}

inline void SPI_Data::rmfNames (const StringArray& value)
{
  //## begin SPI_Data::rmfNames%3E8DBBF2002F.set preserve=no
  m_rmfNames = value;
  //## end SPI_Data::rmfNames%3E8DBBF2002F.set
}

inline const StringArray& SPI_Data::arfNames () const
{
  //## begin SPI_Data::arfNames%3E8DBC22022B.get preserve=no
  return m_arfNames;
  //## end SPI_Data::arfNames%3E8DBC22022B.get
}

inline void SPI_Data::arfNames (const StringArray& value)
{
  //## begin SPI_Data::arfNames%3E8DBC22022B.set preserve=no
  m_arfNames = value;
  //## end SPI_Data::arfNames%3E8DBC22022B.set
}

//## begin module%3AA398BF02CE.epilog preserve=yes
//## end module%3AA398BF02CE.epilog


#endif
